diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mac-low.h ns-3.31/src/wifi/model/mac-low.h
--- ns-3.30.1/src/wifi/model/mac-low.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mac-low.h	2020-06-27 17:38:30.000000000 -0700
@@ -934,11 +958,10 @@
   /*
    * BlockAck data structures.
    */
-  typedef std::pair<Ptr<Packet>, WifiMacHeader> BufferedPacket; //!< buffered packet typedef
-  typedef std::list<BufferedPacket>::iterator BufferedPacketI; //!< buffered packet iterator typedef
+  typedef std::list<Ptr<WifiMacQueueItem>>::iterator BufferedPacketI; //!< buffered packet iterator typedef
 
   typedef std::pair<Mac48Address, uint8_t> AgreementKey; //!< agreement key typedef
-  typedef std::pair<BlockAckAgreement, std::list<BufferedPacket> > AgreementValue; //!< agreement value typedef
+  typedef std::pair<BlockAckAgreement, std::list<Ptr<WifiMacQueueItem>> > AgreementValue; //!< agreement value typedef
 
   typedef std::map<AgreementKey, AgreementValue> Agreements; //!< agreements
   typedef std::map<AgreementKey, AgreementValue>::iterator AgreementsI; //!< agreements iterator
@@ -955,7 +978,7 @@
   bool m_ctsToSelfSupported;             //!< Flag whether CTS-to-self is supported
   WifiTxVector m_currentTxVector;        //!< TXVECTOR used for the current packet transmission
 
-  CfAckInfo m_cfAckInfo; //!< Info about piggyback ACKs used in PCF
+  CfAckInfo m_cfAckInfo; //!< Info about piggyback Acks used in PCF
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mac-low-transmission-parameters.cc ns-3.31/src/wifi/model/mac-low-transmission-parameters.cc
--- ns-3.30.1/src/wifi/model/mac-low-transmission-parameters.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mac-low-transmission-parameters.cc	2020-06-27 17:38:30.000000000 -0700
@@ -27,6 +27,7 @@
 MacLowTransmissionParameters::MacLowTransmissionParameters ()
   : m_nextSize (0),
     m_waitAck (ACK_NONE),
+    m_sendBar (BLOCK_ACK_REQUEST_NONE),
     m_sendRts (false)
 {
 }
@@ -44,33 +45,63 @@
 }
 
 void
-MacLowTransmissionParameters::EnableBasicBlockAck (void)
+MacLowTransmissionParameters::EnableBlockAck (BlockAckType type)
 {
-  m_waitAck = BLOCK_ACK_BASIC;
-}
+  switch (type)
+    {
+    case BlockAckType::BASIC_BLOCK_ACK:
+      m_waitAck = BLOCK_ACK_BASIC;
+      break;
+    case BlockAckType::COMPRESSED_BLOCK_ACK:
+      m_waitAck = BLOCK_ACK_COMPRESSED;
+      break;
+    case BlockAckType::EXTENDED_COMPRESSED_BLOCK_ACK:
+      m_waitAck = BLOCK_ACK_EXTENDED_COMPRESSED;
+      break;
+    case BlockAckType::MULTI_TID_BLOCK_ACK:
+      m_waitAck = BLOCK_ACK_MULTI_TID;
+      break;
+    default:
+      NS_FATAL_ERROR ("Unknown Block ack type");
+      break;
+    }
 
-void
-MacLowTransmissionParameters::EnableCompressedBlockAck (void)
-{
-  m_waitAck = BLOCK_ACK_COMPRESSED;
+  // Reset m_sendBar
+  m_sendBar = BLOCK_ACK_REQUEST_NONE;
 }
 
 void
-MacLowTransmissionParameters::EnableExtendedCompressedBlockAck (void)
+MacLowTransmissionParameters::EnableBlockAckRequest (BlockAckType type)
 {
-  m_waitAck = BLOCK_ACK_EXTENDED_COMPRESSED;
-}
+  switch (type)
+    {
+    case BlockAckType::BASIC_BLOCK_ACK:
+      m_sendBar = BLOCK_ACK_REQUEST_BASIC;
+      break;
+    case BlockAckType::COMPRESSED_BLOCK_ACK:
+      m_sendBar = BLOCK_ACK_REQUEST_COMPRESSED;
+      break;
+    case BlockAckType::EXTENDED_COMPRESSED_BLOCK_ACK:
+      m_sendBar = BLOCK_ACK_REQUEST_EXTENDED_COMPRESSED;
+      break;
+    case BlockAckType::MULTI_TID_BLOCK_ACK:
+      m_sendBar = BLOCK_ACK_REQUEST_MULTI_TID;
+      break;
+    default:
+      NS_FATAL_ERROR ("Unknown Block Ack Request type");
+      break;
+    }
 
-void
-MacLowTransmissionParameters::EnableMultiTidBlockAck (void)
-{
-  m_waitAck = BLOCK_ACK_MULTI_TID;
+  // Reset m_waitAck
+  m_waitAck = ACK_NONE;
 }
 
 void
 MacLowTransmissionParameters::EnableAck (void)
 {
   m_waitAck = ACK_NORMAL;
+  // Reset m_sendBar
+  m_sendBar = BLOCK_ACK_REQUEST_NONE;
 }
 
 void
@@ -80,6 +111,12 @@
 }
 
 void
+MacLowTransmissionParameters::DisableBlockAckRequest (void)
+{
+  m_sendBar = BLOCK_ACK_REQUEST_NONE;
+}
+
+void
 MacLowTransmissionParameters::EnableRts (void)
 {
   m_sendRts = true;
@@ -142,6 +179,50 @@
 }
 
 bool
+MacLowTransmissionParameters::MustSendBlockAckRequest (void) const
+{
+  bool ret;
+  switch (m_sendBar)
+    {
+    case BLOCK_ACK_REQUEST_BASIC:
+    case BLOCK_ACK_REQUEST_COMPRESSED:
+    case BLOCK_ACK_REQUEST_EXTENDED_COMPRESSED:
+    case BLOCK_ACK_REQUEST_MULTI_TID:
+      ret = true;
+      break;
+    default:
+      ret = false;
+      break;
+    }
+  return ret;
+}
+
+BlockAckType
+MacLowTransmissionParameters::GetBlockAckRequestType (void) const
+{
+  BlockAckType type;
+  switch (m_sendBar)
+    {
+    case BLOCK_ACK_REQUEST_BASIC:
+      type = BlockAckType::BASIC_BLOCK_ACK;
+      break;
+    case BLOCK_ACK_REQUEST_COMPRESSED:
+      type = BlockAckType::COMPRESSED_BLOCK_ACK;
+      break;
+    case BLOCK_ACK_REQUEST_EXTENDED_COMPRESSED:
+      type = BlockAckType::EXTENDED_COMPRESSED_BLOCK_ACK;
+      break;
+    case BLOCK_ACK_REQUEST_MULTI_TID:
+      type = BlockAckType::MULTI_TID_BLOCK_ACK;
+      break;
+    default:
+      NS_FATAL_ERROR ("Block ack request must not be sent");
+      break;
+    }
+  return type;
+}
+
+bool
 MacLowTransmissionParameters::MustSendRts (void) const
 {
   return m_sendRts;
@@ -169,22 +250,41 @@
   switch (params.m_waitAck)
     {
     case MacLowTransmissionParameters::ACK_NONE:
-      os << "none";
+      os << "none, ";
       break;
     case MacLowTransmissionParameters::ACK_NORMAL:
-      os << "normal";
+      os << "normal, ";
       break;
     case MacLowTransmissionParameters::BLOCK_ACK_BASIC:
-      os << "basic-block-ack";
+      os << "basic-block-ack, ";
       break;
     case MacLowTransmissionParameters::BLOCK_ACK_COMPRESSED:
-      os << "compressed-block-ack";
+      os << "compressed-block-ack, ";
       break;
     case MacLowTransmissionParameters::BLOCK_ACK_EXTENDED_COMPRESSED:
-      os << "extended-compressed-block-ack";
+      os << "extended-compressed-block-ack, ";
       break;
     case MacLowTransmissionParameters::BLOCK_ACK_MULTI_TID:
-      os << "multi-tid-block-ack";
+      os << "multi-tid-block-ack, ";
+      break;
+    }
+  os << "bar=";
+  switch (params.m_sendBar)
+    {
+    case MacLowTransmissionParameters::BLOCK_ACK_REQUEST_NONE:
+      os << "none";
+      break;
+    case MacLowTransmissionParameters::BLOCK_ACK_REQUEST_BASIC:
+      os << "basic";
+      break;
+    case MacLowTransmissionParameters::BLOCK_ACK_REQUEST_COMPRESSED:
+      os << "compressed";
+      break;
+    case MacLowTransmissionParameters::BLOCK_ACK_REQUEST_EXTENDED_COMPRESSED:
+      os << "extended-compressed";
+      break;
+    case MacLowTransmissionParameters::BLOCK_ACK_REQUEST_MULTI_TID:
+      os << "multi-tid";
       break;
     }
   os << "]";
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mac-low-transmission-parameters.h ns-3.31/src/wifi/model/mac-low-transmission-parameters.h
--- ns-3.30.1/src/wifi/model/mac-low-transmission-parameters.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mac-low-transmission-parameters.h	2020-06-27 17:38:30.000000000 -0700
@@ -42,27 +42,23 @@
   MacLowTransmissionParameters ();
 
   /**
-   * Wait ACKTimeout for an ACK. If we get an ACK
+   * Wait ACKTimeout for an Ack. If we get an Ack
    * on time, call MacLowTransmissionListener::GotAck.
    * Call MacLowTransmissionListener::MissedAck otherwise.
    */
   void EnableAck (void);
   /**
-   * Wait BASICBLOCKACKTimeout for a Basic Block Ack Response frame.
-   */
-  void EnableBasicBlockAck (void);
-  /**
-   * Wait COMPRESSEDBLOCKACKTimeout for a Compressed Block Ack Response frame.
-   */
-  void EnableCompressedBlockAck (void);
-  /**
-   * Wait COMPRESSEDBLOCKACKTimeout for an Extended Compressed Block Ack Response frame.
+   * Wait the timeout corresponding to the given BlockAck response type.
+   *
+   * \param type the BlockAck response type
    */
-  void EnableExtendedCompressedBlockAck (void);
+  void EnableBlockAck (BlockAckType type);
   /**
-   * NOT IMPLEMENTED FOR NOW
+   * Schedule the transmission of a BlockAckRequest of the given type.
+   *
+   * \param type the BlockAckRequest type
    */
-  void EnableMultiTidBlockAck (void);
+  void EnableBlockAckRequest (BlockAckType type);
   /**
    * Send a RTS, and wait CTSTimeout for a CTS. If we get a
    * CTS on time, call MacLowTransmissionListener::GotCts
@@ -72,7 +68,7 @@
   void EnableRts (void);
   /**
    * \param size size of next data to send after current packet is
-   *        sent.
+   *        sent in bytes.
    *
    * Add the transmission duration of the next data to the
    * durationId of the outgoing packet and call
@@ -86,7 +82,11 @@
    */
   void DisableAck (void);
   /**
-   * Do not send rts and wait for cts before sending data.
+   * Do not send BlockAckRequest after data transmission
+   */
+  void DisableBlockAckRequest (void);
+  /**
+   * Do not send RTS and wait for CTS before sending data.
    */
   void DisableRts (void);
   /**
@@ -94,7 +94,7 @@
    */
   void DisableNextData (void);
   /**
-   * \returns true if normal ACK protocol should be used, false
+   * \returns true if normal ack protocol should be used, false
    *          otherwise.
    *
    * \sa EnableAck
@@ -107,12 +107,24 @@
    */
   bool MustWaitBlockAck (void) const;
   /**
-   * \returns the selected block ack variant.
+   * \returns the selected BlockAck variant.
    *
    * Only call this method if the block ack mechanism is used.
    */
   BlockAckType GetBlockAckType (void) const;
   /**
+   * \returns true if a BlockAckRequest must be sent, false otherwise.
+   *
+   * Return true if a BlockAckRequest must be sent, false otherwise.
+   */
+  bool MustSendBlockAckRequest (void) const;
+  /**
+   * \returns the selected BlockAckRequest variant.
+   *
+   * Only call this method if a BlockAckRequest must be sent.
+   */
+  BlockAckType GetBlockAckRequestType (void) const;
+  /**
    * \returns true if RTS should be sent and CTS waited for before
    *          sending data, false otherwise.
    */
@@ -129,7 +141,7 @@
 private:
   friend std::ostream &operator << (std::ostream &os, const MacLowTransmissionParameters &params);
   uint32_t m_nextSize; //!< the next size
-  /// wait ack enumerated type
+  /// wait Ack enumerated type
   enum
   {
     ACK_NONE,
@@ -138,7 +150,16 @@
     BLOCK_ACK_COMPRESSED,
     BLOCK_ACK_EXTENDED_COMPRESSED,
     BLOCK_ACK_MULTI_TID
-  } m_waitAck; //!< wait ack
+  } m_waitAck; //!< wait Ack
+  /// send BAR enumerated type
+  enum
+  {
+    BLOCK_ACK_REQUEST_NONE,
+    BLOCK_ACK_REQUEST_BASIC,
+    BLOCK_ACK_REQUEST_COMPRESSED,
+    BLOCK_ACK_REQUEST_EXTENDED_COMPRESSED,
+    BLOCK_ACK_REQUEST_MULTI_TID
+  } m_sendBar; //!< send BAR
   bool m_sendRts; //!< send an RTS?
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mac-rx-middle.cc ns-3.31/src/wifi/model/mac-rx-middle.cc
--- ns-3.30.1/src/wifi/model/mac-rx-middle.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mac-rx-middle.cc	2020-06-27 17:38:30.000000000 -0700
@@ -22,7 +22,7 @@
 #include "ns3/sequence-number.h"
 #include "ns3/packet.h"
 #include "mac-rx-middle.h"
-#include "wifi-mac-header.h"
+#include "wifi-mac-queue-item.h"
 
 namespace ns3 {
 
@@ -198,7 +198,7 @@
   if (hdr->IsQosData ()
       && !hdr->GetAddr2 ().IsGroup ())
     {
-      /* only for qos data non-broadcast frames */
+      /* only for QoS data non-broadcast frames */
       originator = m_qosOriginatorStatus[std::make_pair (source, hdr->GetQosTid ())];
       if (originator == 0)
         {
@@ -209,8 +209,8 @@
   else
     {
       /* - management frames
-       * - qos data broadcast frames
-       * - nqos data frames
+       * - QoS data broadcast frames
+       * - non-QoS data frames
        * see section 7.1.3.4.1
        */
       originator = m_originatorStatus[source];
@@ -296,9 +296,11 @@
 }
 
 void
-MacRxMiddle::Receive (Ptr<Packet> packet, const WifiMacHeader *hdr)
+MacRxMiddle::Receive (Ptr<WifiMacQueueItem> mpdu)
 {
-  NS_LOG_FUNCTION (packet << hdr);
+  NS_LOG_FUNCTION (*mpdu);
+  const WifiMacHeader* hdr = &mpdu->GetHeader ();
+  Ptr<Packet> packet = mpdu->GetPacket ()->Copy ();
   NS_ASSERT (hdr->IsData () || hdr->IsMgt ());
   if (!m_pcfCallback.IsNull ())
     {
@@ -339,7 +341,18 @@
     {
       originator->SetSequenceControl (hdr->GetSequenceControl ());
     }
-  m_callback (aggregate, hdr);
+  if (aggregate == packet)
+    {
+      m_callback (mpdu);
+    }
+  else
+    {
+      // We could do this in all cases, but passing the received mpdu in case of
+      // A-MSDUs saves us the time to deaggregate the A-MSDU in MSDUs (which are
+      // kept separate in the received mpdu) and allows us to pass the originally
+      // transmitted packets (i.e., with the same UID) to the receiver.
+      m_callback (Create<WifiMacQueueItem> (aggregate, *hdr));
+    }
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mac-rx-middle.h ns-3.31/src/wifi/model/mac-rx-middle.h
--- ns-3.30.1/src/wifi/model/mac-rx-middle.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mac-rx-middle.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,6 +31,7 @@
 class OriginatorRxStatus;
 class Packet;
 class Mac48Address;
+class WifiMacQueueItem;
 
 /**
  * \ingroup wifi
@@ -43,7 +44,7 @@
   /**
    * typedef for callback
    */
-  typedef Callback<void, Ptr<Packet>, const WifiMacHeader*> ForwardUpCallback;
+  typedef Callback<void, Ptr<WifiMacQueueItem>> ForwardUpCallback;
 
   MacRxMiddle ();
   ~MacRxMiddle ();
@@ -51,24 +52,23 @@
   /**
    * Set a callback to forward the packet up.
    *
-   * \param callback
+   * \param callback the callback to set
    */
   void SetForwardCallback (ForwardUpCallback callback);
 
   /**
    * Set a callback to trigger the next PCF frame.
    *
-   * \param callback
+   * \param callback the callback to set
    */
   void SetPcfCallback (Callback<void> callback);
 
   /**
    * Receive a packet.
    *
-   * \param packet the packet
-   * \param hdr MAC header
+   * \param mpdu the MPDU
    */
-  void Receive (Ptr<Packet> packet, const WifiMacHeader *hdr);
+  void Receive (Ptr<WifiMacQueueItem> mpdu);
 
 
 private:
@@ -79,7 +79,7 @@
    * (by looking at ADDR2 field in the header).
    * The method creates a new OriginatorRxStatus if one is not already presented.
    *
-   * \param hdr
+   * \param hdr the MAC header
    *
    * \return OriginatorRxStatus
    */
@@ -88,8 +88,8 @@
    * Check if we have already received the packet from the sender before
    * (by looking at the sequence control field).
    *
-   * \param hdr
-   * \param originator
+   * \param hdr the MAC header
+   * \param originator the packet originator status
    *
    * \return true if we already received the packet previously,
    *         false otherwise
@@ -103,9 +103,9 @@
    * If the packet is the last fragment, the method tries to re-construct the full packet
    * and return the packet if success.
    *
-   * \param packet
-   * \param hdr
-   * \param originator
+   * \param packet the packet
+   * \param hdr the MAC header
+   * \param originator the packet originator status
    *
    * \return a packet if the packet is successfully reassembled (or not a fragment),
    *         0 if we failed to reassemble the packet (e.g. missing fragments/out-of-order).
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mgt-headers.cc ns-3.31/src/wifi/model/mgt-headers.cc
--- ns-3.30.1/src/wifi/model/mgt-headers.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mgt-headers.cc	2020-06-27 17:38:30.000000000 -0700
@@ -49,21 +49,15 @@
 }
 
 void
-MgtAssocResponseHeader::SetAssociationId (uint16_t aid)
-{
-  m_aid = aid;
-}
-
-void
 MgtProbeRequestHeader::SetSupportedRates (SupportedRates rates)
 {
   m_rates = rates;
 }
 
 void
-MgtProbeRequestHeader::SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities)
+MgtProbeRequestHeader::SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities)
 {
-  m_extendedCapability = extendedcapabilities;
+  m_extendedCapability = extendedCapabilities;
 }
 
 ExtendedCapabilities
@@ -73,9 +67,9 @@
 }
 
 void
-MgtProbeRequestHeader::SetHtCapabilities (HtCapabilities htcapabilities)
+MgtProbeRequestHeader::SetHtCapabilities (HtCapabilities htCapabilities)
 {
-  m_htCapability = htcapabilities;
+  m_htCapability = htCapabilities;
 }
 
 HtCapabilities
@@ -85,9 +79,9 @@
 }
 
 void
-MgtProbeRequestHeader::SetVhtCapabilities (VhtCapabilities vhtcapabilities)
+MgtProbeRequestHeader::SetVhtCapabilities (VhtCapabilities vhtCapabilities)
 {
-  m_vhtCapability = vhtcapabilities;
+  m_vhtCapability = vhtCapabilities;
 }
 
 VhtCapabilities
@@ -97,9 +91,9 @@
 }
 
 void
-MgtProbeRequestHeader::SetHeCapabilities (HeCapabilities hecapabilities)
+MgtProbeRequestHeader::SetHeCapabilities (HeCapabilities heCapabilities)
 {
-  m_heCapability = hecapabilities;
+  m_heCapability = heCapabilities;
 }
 
 HeCapabilities
@@ -235,9 +229,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities)
+MgtProbeResponseHeader::SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities)
 {
-  m_extendedCapability = extendedcapabilities;
+  m_extendedCapability = extendedCapabilities;
 }
 
 ExtendedCapabilities
@@ -247,9 +241,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetHtCapabilities (HtCapabilities htcapabilities)
+MgtProbeResponseHeader::SetHtCapabilities (HtCapabilities htCapabilities)
 {
-  m_htCapability = htcapabilities;
+  m_htCapability = htCapabilities;
 }
 
 HtCapabilities
@@ -259,9 +253,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetHtOperation (HtOperation htoperation)
+MgtProbeResponseHeader::SetHtOperation (HtOperation htOperation)
 {
-  m_htOperation = htoperation;
+  m_htOperation = htOperation;
 }
 
 HtOperation
@@ -271,9 +265,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetVhtCapabilities (VhtCapabilities vhtcapabilities)
+MgtProbeResponseHeader::SetVhtCapabilities (VhtCapabilities vhtCapabilities)
 {
-  m_vhtCapability = vhtcapabilities;
+  m_vhtCapability = vhtCapabilities;
 }
 
 VhtCapabilities
@@ -283,9 +277,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetVhtOperation (VhtOperation vhtoperation)
+MgtProbeResponseHeader::SetVhtOperation (VhtOperation vhtOperation)
 {
-  m_vhtOperation = vhtoperation;
+  m_vhtOperation = vhtOperation;
 }
 
 VhtOperation
@@ -295,9 +289,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetHeCapabilities (HeCapabilities hecapabilities)
+MgtProbeResponseHeader::SetHeCapabilities (HeCapabilities heCapabilities)
 {
-  m_heCapability = hecapabilities;
+  m_heCapability = heCapabilities;
 }
 
 HeCapabilities
@@ -307,9 +301,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetHeOperation (HeOperation heoperation)
+MgtProbeResponseHeader::SetHeOperation (HeOperation heOperation)
 {
-  m_heOperation = heoperation;
+  m_heOperation = heOperation;
 }
 
 HeOperation
@@ -319,9 +313,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetCfParameterSet (CfParameterSet cfparameterset)
+MgtProbeResponseHeader::SetCfParameterSet (CfParameterSet cfParameterSet)
 {
-  m_cfParameterSet = cfparameterset;
+  m_cfParameterSet = cfParameterSet;
 }
 
 CfParameterSet
@@ -373,9 +367,9 @@
 }
 
 void
-MgtProbeResponseHeader::SetEdcaParameterSet (EdcaParameterSet edcaparameters)
+MgtProbeResponseHeader::SetEdcaParameterSet (EdcaParameterSet edcaParameters)
 {
-  m_edcaParameterSet = edcaparameters;
+  m_edcaParameterSet = edcaParameters;
 }
 
 EdcaParameterSet
@@ -446,12 +440,12 @@
   //timestamp
   //beacon interval
   //capability information
-  //ssid
+  //SSID
   //supported rates
-  //fh parameter set
-  //ds parameter set
-  //cf parameter set
-  //ibss parameter set
+  //FH parameter set
+  //DS parameter set
+  //CF parameter set
+  //IBSS parameter set
   Buffer::Iterator i = start;
   i.WriteHtolsbU64 (Simulator::Now ().GetMicroSeconds ());
   i.WriteHtolsbU16 (static_cast<uint16_t> (m_beaconInterval / 1024));
@@ -563,9 +557,9 @@
 }
 
 void
-MgtAssocRequestHeader::SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities)
+MgtAssocRequestHeader::SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities)
 {
-  m_extendedCapability = extendedcapabilities;
+  m_extendedCapability = extendedCapabilities;
 }
 
 ExtendedCapabilities
@@ -575,9 +569,9 @@
 }
 
 void
-MgtAssocRequestHeader::SetHtCapabilities (HtCapabilities htcapabilities)
+MgtAssocRequestHeader::SetHtCapabilities (HtCapabilities htCapabilities)
 {
-  m_htCapability = htcapabilities;
+  m_htCapability = htCapabilities;
 }
 
 HtCapabilities
@@ -587,9 +581,9 @@
 }
 
 void
-MgtAssocRequestHeader::SetVhtCapabilities (VhtCapabilities vhtcapabilities)
+MgtAssocRequestHeader::SetVhtCapabilities (VhtCapabilities vhtCapabilities)
 {
-  m_vhtCapability = vhtcapabilities;
+  m_vhtCapability = vhtCapabilities;
 }
 
 VhtCapabilities
@@ -599,9 +593,9 @@
 }
 
 void
-MgtAssocRequestHeader::SetHeCapabilities (HeCapabilities hecapabilities)
+MgtAssocRequestHeader::SetHeCapabilities (HeCapabilities heCapabilities)
 {
-  m_heCapability = hecapabilities;
+  m_heCapability = heCapabilities;
 }
 
 HeCapabilities
@@ -750,9 +744,9 @@
 }
 
 void
-MgtReassocRequestHeader::SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities)
+MgtReassocRequestHeader::SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities)
 {
-  m_extendedCapability = extendedcapabilities;
+  m_extendedCapability = extendedCapabilities;
 }
 
 ExtendedCapabilities
@@ -762,9 +756,9 @@
 }
 
 void
-MgtReassocRequestHeader::SetHtCapabilities (HtCapabilities htcapabilities)
+MgtReassocRequestHeader::SetHtCapabilities (HtCapabilities htCapabilities)
 {
-  m_htCapability = htcapabilities;
+  m_htCapability = htCapabilities;
 }
 
 HtCapabilities
@@ -774,9 +768,9 @@
 }
 
 void
-MgtReassocRequestHeader::SetVhtCapabilities (VhtCapabilities vhtcapabilities)
+MgtReassocRequestHeader::SetVhtCapabilities (VhtCapabilities vhtCapabilities)
 {
-  m_vhtCapability = vhtcapabilities;
+  m_vhtCapability = vhtCapabilities;
 }
 
 VhtCapabilities
@@ -786,9 +780,9 @@
 }
 
 void
-MgtReassocRequestHeader::SetHeCapabilities (HeCapabilities hecapabilities)
+MgtReassocRequestHeader::SetHeCapabilities (HeCapabilities heCapabilities)
 {
-  m_heCapability = hecapabilities;
+  m_heCapability = heCapabilities;
 }
 
 HeCapabilities
@@ -953,9 +947,9 @@
 }
 
 void
-MgtAssocResponseHeader::SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities)
+MgtAssocResponseHeader::SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities)
 {
-  m_extendedCapability = extendedcapabilities;
+  m_extendedCapability = extendedCapabilities;
 }
 
 ExtendedCapabilities
@@ -965,9 +959,9 @@
 }
 
 void
-MgtAssocResponseHeader::SetHtCapabilities (HtCapabilities htcapabilities)
+MgtAssocResponseHeader::SetHtCapabilities (HtCapabilities htCapabilities)
 {
-  m_htCapability = htcapabilities;
+  m_htCapability = htCapabilities;
 }
 
 HtCapabilities
@@ -977,9 +971,9 @@
 }
 
 void
-MgtAssocResponseHeader::SetHtOperation (HtOperation htoperation)
+MgtAssocResponseHeader::SetHtOperation (HtOperation htOperation)
 {
-  m_htOperation = htoperation;
+  m_htOperation = htOperation;
 }
 
 HtOperation
@@ -989,9 +983,9 @@
 }
 
 void
-MgtAssocResponseHeader::SetVhtCapabilities (VhtCapabilities vhtcapabilities)
+MgtAssocResponseHeader::SetVhtCapabilities (VhtCapabilities vhtCapabilities)
 {
-  m_vhtCapability = vhtcapabilities;
+  m_vhtCapability = vhtCapabilities;
 }
 
 VhtCapabilities
@@ -1001,9 +995,9 @@
 }
 
 void
-MgtAssocResponseHeader::SetVhtOperation (VhtOperation vhtoperation)
+MgtAssocResponseHeader::SetVhtOperation (VhtOperation vhtOperation)
 {
-  m_vhtOperation = vhtoperation;
+  m_vhtOperation = vhtOperation;
 }
 
 VhtOperation
@@ -1013,9 +1007,9 @@
 }
 
 void
-MgtAssocResponseHeader::SetHeCapabilities (HeCapabilities hecapabilities)
+MgtAssocResponseHeader::SetHeCapabilities (HeCapabilities heCapabilities)
 {
-  m_heCapability = hecapabilities;
+  m_heCapability = heCapabilities;
 }
 
 HeCapabilities
@@ -1025,9 +1019,9 @@
 }
 
 void
-MgtAssocResponseHeader::SetHeOperation (HeOperation heoperation)
+MgtAssocResponseHeader::SetHeOperation (HeOperation heOperation)
 {
-  m_heOperation = heoperation;
+  m_heOperation = heOperation;
 }
 
 HeOperation
@@ -1037,6 +1031,18 @@
 }
 
 void
+MgtAssocResponseHeader::SetAssociationId (uint16_t aid)
+{
+  m_aid = aid;
+}
+
+uint16_t
+MgtAssocResponseHeader::GetAssociationId (void) const
+{
+  return m_aid;
+}
+
+void
 MgtAssocResponseHeader::SetErpInformation (ErpInformation erpInformation)
 {
   m_erpInformation = erpInformation;
